var http = require('http'),
https = require('https');


exports.plugin = function(router, params) 
{

	var servers = {};

	
    router.on({

    	/**
    	 */

        'push init': function()
        {
        	//params present? start the http port
			if(params)
			{
				if(params.http)
				{
					router.pull('http/start', params.http, function(){});
				}
			}
	    },    

	    /**
	     */

	    'pull http/start': function(request)
	    {
	    	var secure = request.data.secure,
	    	port = request.data.port || (secure ? 443 : 8000),
		    serv = secure ? https : http;
	    	
	    	if(servers[secure]) return servers[secure];

	    	var inst = servers[secure] = serv.createServer();


	    	try
	    	{
	    		inst.listen(port);

	    		router.push('http/server', inst);
	    	}
	    	catch(e)
	    	{
	    		console.error('Unable to start http server on port %d', port);
	    	}
	    }
    })
}
