var http = require('http'), https = require('https'), Structr = require('sk/core/struct'),
fs = require('fs');

var Server = Structr({
    '_onRequest': function(req, res) {
		
        this.onRequestt(req, res);
        // this.router().handleHTTPRequest(req, res);

        req.on('error', function(exc) {
            console.error('ignoring exception ' + exec);
        })
    },
    connect: function(port, onRequest)
    {
        this.port(port);
        this.onRequestt = onRequest;


        function connect2()
        {
            
        }

        if(this._server)
        {
            this._server.close();
        }

        try {
           this._server = this._initServer();
        }catch(e)
        {
            console.error('Unable to start server on port '+this.port());
            console.error(e.stack);
        }
    },
    'explicit port': 1,
    'final start': function() {
		
		
        return this;
    },
    'abstract _initServer': function() {
    
    }
});

var HttpServer = Server.extend({
    '_initServer': function() {
        console.ok("Starting up http server port=" + this.port());
        var server = http.createServer(this.getMethod('_onRequest'));

        server.listen(this.port());
        return server;
    }
});

var HttpsServer = Server.extend({
    '_initServer': function() {
        console.ok("Starting up http server port=" + this.port());
        
        var options = {
            key: fs.readFileSync(__dirname + '/cert/privatekey.pem'),
            cert: fs.readFileSync(__dirname + '/cert/certificate.pem')
        }
        
        var server = https.createServer(options, this.getMethod('_onRequest'));
        server.listen(this.port());
        return server;
    }
});

exports.getInitializer = function(clazz, defaultPort, onRequest) {
    var server;
    
    return function() 
    {
        return (server || (server = new clazz())).connect(this.data.port || defaultPort, onRequest);
    }
}

exports.Http = HttpServer;
exports.Https = HttpsServer;
